// =================================
// Working with Delphi sets.
// =================================
//
// LMD Script Control allows you to work with Delphi sets.
// In COM type model sets are represented as numbers. So,
// script control supports only sets with:
// SizeOf(<SetType>) <= SizeOf(Integer).
// Hovewer, almost all VCL sets fit in this restriction.
//
// Note: PascalScript suports native 'in' operator that allows to
//       test whether the element is in the set. It also supports
//       Delphi like set constructors. So, there are no need to 
//       use SetIn and SetEmpty functions.

procedure Main;
var
  form, s;
begin
    // Create a form and change some of it's set properties:

    form             := TForm.Create(Application);
    form.Caption     := 'LMD Script Control Sets Demo';
    form.Position    := poScreenCenter;
    form.BorderIcons := [biSystemMenu, biMinimize];
    form.Font.Style  := [];

    form.ShowModal;

    // More sets examples:

    s := [];
    Include(s, fsBold);

    if fsBold in s then
        MessageList.Lines.Add('Set variable "s" includes "fsBold"');

    if not (fsItalic in s) then
        MessageList.Lines.Add('Set variable "s" does not includes "fsItalic"');
end;


