' ============================
' Working with Delphi classes.
' ============================

' LMD Script Control allows you to work with Delphi classes.
' You can create and destroy objects in script, access to its
' public interface: call methods, access fields and properties.
' Script Control supports properties with parameters.
' Script Control fully supports Delphi metaclasses, including
' storing references to metaclasses in script variables and
' polimorphic calls of virtual metaclass methods.

sub Main
    'Create new form with a memo:

    dim form      = new TForm(Application)
    form.Caption  = "Delphi Class Usage Demo"
    form.Position = poScreenCenter

    dim memo      = new TMemo(form)
    memo.Parent   = form
    memo.Align    = alClient
    memo.Lines.Add "Hellow from script :)"

    form.ShowModal

    'Metaclass usage:

    MessageList.Lines.Add "Created form class is: " + form.ClassType.ClassName

    dim cls = TComponent
    if typeof form is cls then  
        MessageList.Lines.Add "Our form is TComponent"
    end if

    if typeof form is TForm then
        MessageList.Lines.Add "Our form is TForm as well"
    end if

    'Create an object using metaclass reference
    'and virtual constructor: 

    dim formcls = TForm, form2
    form2 = new formcls(Application)

    form2.Free      'Don't show this form,
                    'just destroy it.
end sub

